import { ResolutionCondition } from '../types';
import { TokenType, TokenValue } from '../pointers';
import { DependencyModule } from './DependencyModule';
export declare class Container extends DependencyModule {
    private snapshot;
    extend(container: Container | null): this;
    clone(): Container;
    capture(): void;
    restore(): void;
    get<T extends TokenValue>(token: T): TokenType<T>;
    /**
     * @access package
     * @deprecated `conditions` argument is added for internal use.
     *              Use it if you really understand that it is necessary.
     */
    get<T extends TokenValue>(token: T, conditions: ResolutionCondition[]): TokenType<T>;
    private resolveTokens;
    private resolveToken;
    private resolveBinding;
    private resolveCache;
    private createInstance;
    private getParameters;
}
