import { UnknownCreator } from '../../types';
import type { Container } from '../Container';
import { Binding, Scope, Type } from './Binding';
export interface InstanceBinding extends Binding {
    readonly impl: UnknownCreator;
    readonly type: Type.Instance;
}
export declare class InstanceContainerScopedBinding implements InstanceBinding {
    readonly impl: UnknownCreator;
    readonly type = Type.Instance;
    readonly scope = Scope.Container;
    readonly cache: WeakMap<Container, unknown>;
    constructor(impl: UnknownCreator);
}
export declare class InstanceResolutionScopedBinding implements InstanceBinding {
    readonly impl: UnknownCreator;
    readonly type = Type.Instance;
    readonly scope = Scope.Resolution;
    constructor(impl: UnknownCreator);
}
export declare class InstanceSingletonScopedBinding implements InstanceBinding {
    readonly impl: UnknownCreator;
    readonly type = Type.Instance;
    readonly scope = Scope.Singleton;
    cache?: unknown;
    constructor(impl: UnknownCreator);
}
export declare class InstanceTransientScopedBinding implements InstanceBinding {
    readonly impl: UnknownCreator;
    readonly type = Type.Instance;
    readonly scope = Scope.Transient;
    constructor(impl: UnknownCreator);
}
export declare const isInstanceBinding: (binding: Binding) => binding is InstanceBinding;
export declare const isInstanceContainerScopedBinding: (binding: InstanceBinding) => binding is InstanceContainerScopedBinding;
export declare const isInstanceResolutionScopedBinding: (binding: InstanceBinding) => binding is InstanceResolutionScopedBinding;
export declare const isInstanceSingletonScopedBinding: (binding: InstanceBinding) => binding is InstanceSingletonScopedBinding;
